
	org	0100H

; test RPAIRS register-pair syntax

	RPAIRS 0		;no numeric values
	RPAIRS "evan"	;wrong string

	RPAIRS "EVENS"
;21-2F SRC reg pair (0 2 4 6 8 10 12 14)
; 0010rrr1

	SRC	0
	SRC	1 ;should be error
	SRC	2
	SRC	3 ;should be error
	SRC	4
	SRC	5 ;should be error
	SRC	6
	SRC	7 ;should be error
	SRC	8  
	SRC	9 ;should be error 
	SRC	10  
	SRC	11 ;should be error 
	SRC	12  
	SRC	13 ;should be error 
	SRC	14  
	SRC	15 ;should be error 
	SRC	16 ;should be error 

	RPAIRS "ZERO7"
;21-2F SRC reg pair (0,7)
; 0010rrr1

	SRC	0
	SRC	1
	SRC	2
	SRC	3
	SRC	4
	SRC	5
	SRC	6
	SRC	7
	SRC	8 ;should be error
	SRC	9 ;should be error
	SRC	10 ;should be error
	SRC	11 ;should be error
	SRC	12 ;should be error
	SRC	13 ;should be error
	SRC	14 ;should be error 
	SRC	15 ;should be error
	SRC	16 ;should be error
;
; test some radix conversions
	DW	1234	;decimal default
	DW	1234D	;also decimal
	DW	1234H	;hex
	DW	$1234	;hex
	DB	10101010B ;binary
	DB	%10101010 ;binary
	DW	1234Q	;octal
	DW	@1234	;octal
	DB	@9	;bad octal
	DB	0AD	;bad decimal
	DB	2B	;bad binary
	DB	%2	;bad binary


	ORg	0000H
	NOP	;00H

;01-0E 4040 only
	HLT
	BBS
	LCR
	OR4
	OR5
	AN6
	AN7
	DB0
	DB1
	SB0
	SB1
	EIN
	DIN
	RPM
;0F undefined

;10-1F JCN	condition, byte address - jump on condition
; 0001cccc aaaaaaaa
; bit 0 is test
; bit 1 is carry
; bit 2 is zero
; bit 3 inverts other conditions
ALPHA:	
	JCN 0,ALPHA
	JNT  ALPHA
	JC   BETA
	JZ   PAGE1	;should be error, jump to another page
	JT   BETA
	JNC	ALPHA
	JNZ	$
	JCN 15,BETA
	JCN 15 BETA	;error, no comma 
BETA:
;note: if JCN is assembled at 0XXFE or 0XXFF, 
;jump addresses NEXT page of RAM. See test at end of ASM file. 


;20-2E FIM reg pair (0-7), byte data
; 0010rrr0 dddddddd

	FIM	-1,FFH ;should be error
	FIM	0,12H
	FIM	1,43H
	FIM	7,56H
	FIM	8,78H	;should be error no such register-pair
	FIM	4 55H	;error space no comma
	FIM	7,GAMMA	; data larger than 8-bits but truncated to 8-bits
			; error if address executed outside current page

;21-2F SRC reg pair (0,7)
; 0010rrr1

	SRC	0
	SRC	1
	SRC	2
	SRC	3
	SRC	4
	SRC	5
	SRC	6
	SRC	7
	SRC	8 ;should be error

;30-3E FIN reg pair (0,7)
; 0011rrr0

	FIN	0
	FIN	1
	FIN	2
	FIN	3
	FIN	4
	FIN	5
	FIN	6
	FIN	7
	FIN	8 ;should be error
;note: if FIN is assembled at 0XXFF, 
;load addresses NEXT page of RAM. See test at end of ASM file. 

;31-3F JIN reg pair (0,7) indirect jump
; 0011rrr1

	JIN	0
	JIN	1
	JIN	2
	JIN	3
	JIN	4
	JIN	5
	JIN	6
	JIN	7
	JIN	8 ;should be error
;note: if JIN is assembled at 0XXFF, 
;jump addresses NEXT page of RAM. See test at end of ASM file. 


;40-4F JUN 12-bit address
;0100aaaa aaaaaaaa
	JUN	0001H
	JUN	ALPHA
	JUN	0FEDH
	JUN	1000H	;should be error

;50-5F JMS 12-bit address
;0100aaaa aaaaaaaa
	JMS	BETA
	JMS	0765H
	JMS	0FEDH
	JMS	OUTSIDE	;should be error

;60-6F 4004 INC	reg (0 to 15)
;0110rrrr
	INC	-1	;should be error
	INC	0
	INC	1
	INC	2
	INC	3
	INC	4
	INC	5
	INC	6
	INC	7
	INC	8
	INC 9
	INC	10
	INC	11
	INC	12
	INC	13
	INC	14
	INC 15
	INC 16	;should be error

;70-7F ISZ	reg (0-15), byte address - incr and skip to on zero
;0111rrrr aaaaaaaa
;let's test some radix conversions
	ISZ  0,128
	ISZ  1,0FFH
	ISZ  2,BETA
	ISZ  3,337O
	ISZ  4,10101010B
	ISZ  6 128	;error space no comma

;test some page addressing, use lower 8 bits of operand for address
	ISZ  5,PAGE0	;should be OK
	ISZ  7,PAGE1	;should be error
	ISZ  15, low(0FFFH) ;bad form but should pass
;note: if ISZ is assembled at 0XXFE or 0XXFF, 
;skip goes to NEXT page of RAM. See test at end of ASM file. 

;80-8F ADD reg (0-15)
;1000rrrr
	ADD	0
	ADD	15

;90-9F SUB reg (0-15)
;1001rrrr 
	SUB	0
	SUB	15

;A0-AF LD reg (0-15)
;1010rrrr 
	LD	0
	LD	15

;B0-Bf XCH reg (0-15)
;1010rrrr
	XCH	0
	XCH	15

;C0-CF BBL data (4-bit)
;1100dddd
	BBL	0
	BBL	15

;D0-DF LDM data (4-bit)
;1101dddd
	LDM	0
	LDM	15

;E0-EF I-O & RAM instructions
	WRM
	WMP
	WRR
	WPM
	WR0
	WR1
	WR2
	WR3
	SBM
	RDM
	RDR
	ADM
	RD0
	RD1
	RD2
	RD3

;F0-FF
	CLB
	CLC
	IAC
	CMC
	CMA
	RAL
	RAR
	TCC
	DAC
	TCS
	STC
	DAA
	KBP
	DCL
;FE, FF undefined

;!testing tick operand seperator
	RD0 ! RD1 ! RD2	; support ! seperator one space?
	RD0!RD1!RD2	; support ! with no spaces?

;test page-boundary errors

	ORG	0FFH	;end of zeroth page
PAGE0: JIN	7 	;error: if JIN is assembled at 0XXFF, 
			;jump addresses NEXT page of RAM - error
PAGE1: DB 00	;start of 1st page

	ISZ	7,ALPHA	;should be error, wrong page

	ORG	1FEH	; end of 1st page
GAMMA:	ISZ  0,GAMMA	;error: if ISZ or JCN is assembled at 0XXFE or 0XXFF, 
			;skip addresses NEXT page of RAM

	ORG	2FFH	;end of page
 	FIN	7 	;error: if JIN is assembled at 0XXFF, 
			;reg access addresses NEXT page of RAM - error
	DB 00		;start of next  page


	ORG	1234H	;outside 12-bit range
OUTSIDE: DB 00

	END

	